###########################################################################
#
#   SuPy - Mixin modules for observer class
#
###########################################################################

module PyAppObserver

	def onNewModel(model)
		method_missing(:onNewModel, model)
	end

	def onOpenModel(*args)
		method_missing(:onOpenModel, *args)
	end

	def onQuit(*args)
		method_missing(:onQuit, *args)
	end

end

module PyDefinitionsObserver

	def onComponentAdded(*args)
		method_missing(:onComponentAdded, *args)
	end
	
	def onComponentPropertiesChanged(*args)
		method_missing(:onComponentPropertiesChanged, *args)
	end
	
	def onComponentRemoved(*args)
		method_missing(:onComponentRemoved, *args)
	end
	
	def onComponentTypeChanged(*args)
		method_missing(:onComponentTypeChanged, *args)
	end
	
end

module PyDefinitionObserver

	def onComponentInstanceAdded(*args)
		method_missing(:onComponentInstanceAdded, *args)
	end
	
	def onComponentInstanceRemoved(*args)
		method_missing(:onComponentInstanceRemoved, *args)
	end

end

module PyEntitiesObserver

	def onElementAdded(*args)
		method_missing(:onElementAdded, *args)
	end
	
	def onElementRemoved(*args)
		method_missing(:onElementRemoved, *args)
	end
	
	def onContentsModified(*args)
		method_missing(:onContentsModified, *args)
	end
	
end

module PyEntityObserver

	def onEraseEntity(arg)
		method_missing(:onEraseEntity, arg)
	end
	
	def onChangeEntity(arg)
		method_missing(:onChangeEntity, arg)
	end
	
end

module PyInstanceObserver

	def onOpen(arg)
		method_missing(:onOpen, arg)
	end
	
	def onClose(arg)
		method_missing(:onClose, arg)
	end
	
end

module PyLayersObserver

	def onCurrentLayerAdded(*args)
		method_missing(:onCurrentLayerAdded, *args)
	end

	def onLayerAdded(*args)
		method_missing(:onLayerAdded, *args)
	end
	
	def onLayerRemoved(*args)
		method_missing(:onLayerRemoved, *args)
	end
	
	def onRemoveAllLayers(arg)
		method_missing(:onRemoveAllLayers, arg)
	end
	
end

module PyMaterialsObserver

	def onMaterialAdd(*args)
		method_missing(:onMaterialAdd, *args)
	end
	
	def onMaterialChange(*args)
		method_missing(:onMaterialChange, *args)
	end
	
	def onMaterialRemove(*args)
		method_missing(:onMaterialRemove, *args)
	end
	
	def onMaterialRefChange(*args)
		method_missing(:onMaterialRefChange, *args)
	end
	
	def onMaterialSetCurrent(*args)
		method_missing(:onMaterialSetCurrent, *args)
	end
	
	def onMaterialUndoRedo(*args)
		method_missing(:onMaterialUndoRedo, *args)
	end
	
	def onMaterialRemoveAll(*args)
		method_missing(:onMaterialRemoveAll, *args)
	end
	
end

module PyModelObserver

	def onDeleteModel(arg)
		method_missing(:onDeleteModel, arg)
	end
	
	def onEraseAll(arg)
		method_missing(:onEraseAll, arg)
	end
	
	def onTransactionEnd(arg)
		method_missing(:onTransactionEnd, arg)
	end
	
	def onTransactionStart(arg)
		method_missing(:onTransactionStart, arg)
	end
	
end

module PyOptionsProviderObserver

	def onOptionsProviderChanged(*args)
		method_missing(:onOptionsProviderChanged, *args)
	end
	
end

module PyPagesObserver

	def onElementAdded(*args)
		method_missing(:onElementAdded, *args)
	end
	
	def onElementRemoved(*args)
		method_missing(:onElementRemoved, *args)
	end
	
	def onContentsModified(*args)
		method_missing(:onContentsModified, *args)
	end

end

#module PyRenderingOptionsObserver
#
# # What methods does this have? Ruby docs are incoherent.
#	
#end

module PySelectionObserver

	def onSelectionAdded(*args)
		method_missing(:onSelectionAdded, *args)
	end
	
	def onSelectionBulkChange(arg)
		method_missing(:onSelectionBulkChange, arg)
	end
	
	def onSelectionCleared(arg)
		method_missing(:onSelectionCleared, arg)
	end
	
	def onSelectionRemoved(*args)
		method_missing(:onSelectionRemoved, *args)
	end
	
end

module PyShadowInfoObserver

	def onShadowInfoChanged(*args)
		method_missing(:onShadowInfoChanged, *args)
	end
	
end

module PyToolsObserver

	def onActiveToolChanged(*args)
		method_missing(:onActiveToolChanged, *args)
	end
	
	def onToolStateChanged(*args)
		method_missing(:onToolStateChanged, *args)
	end
	
end

module PyViewObserver

	def onViewChanged(arg)
		method_missing(:onViewChanged, arg)
	end

end
